//Method Library
//EasyMenu Menu Creation System
//Version 1.21
//Copyright (c) Finalis Software 2006

Method CreateCell(x1!,y1!,x2!,y2!,layer!,type$,image_filename$)
{
	num$=CastLit(number_of_cells!)
	layer$=CastLit(layer!)
	cell[number_of_cells!][layer]!=layer!
	If(layer! > max_layer!)
	{
		cell[number_of_cells!][layer]!=max_layer!
	}
	ElseIf(layer! < 0)
	{
		cell[number_of_cells!][layer]!=0
	}
	cell[number_of_cells!][type]$=type$
	cell[number_of_cells!][texty]!=(y1!+y2!)/2
	cell[number_of_cells!][text]$=num$+"; "+type$+"; "+"layer "+layer$
	cell[number_of_cells!][image]$=image_filename$
	cell[cellnum!][translucent]!=0
	If(x2! >= x1!)
	{
		cell[number_of_cells!][width]!=x2!-x1!
		cell[number_of_cells!][x1]!=x1!
		cell[number_of_cells!][x2]!=x2!
		cell[number_of_cells!][textx]!=x1!
	}
	Else
	{
		cell[number_of_cells!][width]!=x1!-x2!
		cell[number_of_cells!][x1]!=x2!
		cell[number_of_cells!][x2]!=x1!
		cell[number_of_cells!][textx]!=x2!
	}
	If(y2! >= y1!)
	{
		cell[number_of_cells!][height]!=y2!-y1!
		cell[number_of_cells!][y1]!=y1!
		cell[number_of_cells!][y2]!=y2!
	}
	Else
	{
		cell[number_of_cells!][height]!=y1!-y2!
		cell[number_of_cells!][y1]!=y2!
		cell[number_of_cells!][y2]!=y1!
	}
	number_of_cells!=number_of_cells!+1
	Kill(num$)
	Kill(layer$)
}



Method RenderCell(cellnum!,canvas!)
{
	switch(cell[cellnum!][type]$)
	{
		case("button") {
			button[buttonnumbo!]!=cellnum!
			buttonnumbo!=buttonnumbo!+1
		}
		case("static_var") {
			osize!=getfontsize()
			fontsize(cell[cellnum!][fontsize]!)
			Switch(cell[cellnum!][static_var_type]$)
			{
				case("numeric") {
					rpgcode("valueoo$=castlit("+cell[cellnum!][static_var_complete]$+")")
				}
				case("literal") {
					rpgcode("valueoo$="+cell[cellnum!][static_var_complete]$)
				}
			}
			PixelText(cell[cellnum!][textx]!,cell[cellnum!][texty]!,valueoo$,canvas!)
			fontsize(osize!)
			kill(osize!)
		}
		case("image_var") {
			If(cell[cellnum!][translucent]!==1)
			{
				rpgcode("SetImageTranslucent("+cell[cellnum!][image_var]$+"$,cell[cellnum!][x1]!,cell[cellnum!][y1]!,cell[cellnum!][width]!,cell[cellnum!][height]!,canvas!)")
			}
			ElseIf(cell[cellnum!][translucent]!==2)
			{
				rpgcode("SetImageTransparent("+cell[cellnum!][image_var]$+"$,cell[cellnum!][x1]!,cell[cellnum!][y1]!,cell[cellnum!][width]!,cell[cellnum!][height]!,cell[cellnum!][tr]!,cell[cellnum!][tg]!,cell[cellnum!][tb]!,canvas!)")
			}
			Else
			{
				rpgcode("SetImage("+cell[cellnum!][image_var]$+"$,cell[cellnum!][x1]!,cell[cellnum!][y1]!,cell[cellnum!][width]!,cell[cellnum!][height]!,canvas!)")
			}
		}
		case("text") {
			osize!=getfontsize()
			fontsize(cell[cellnum!][fontsize]!)
			PixelText(cell[cellnum!][textx]!,cell[cellnum!][texty]!,cell[cellnum!][display_text]$,canvas!)
			fontsize(osize!)
			kill(osize!)
		}
		case(Else) {
			If(cell[cellnum!][translucent]!==1)
			{
				SetImageTranslucent(cell[cellnum!][image]$,cell[cellnum!][x1]!,cell[cellnum!][y1]!,cell[cellnum!][width]!,cell[cellnum!][height]!,canvas!)
			}
			ElseIf(cell[cellnum!][translucent]!==2)
			{
				SetImageTransparent(cell[cellnum!][image]$,cell[cellnum!][x1]!,cell[cellnum!][y1]!,cell[cellnum!][width]!,cell[cellnum!][height]!,cell[cellnum!][tr]!,cell[cellnum!][tg]!,cell[cellnum!][tb]!,canvas!)
			}
			Else
			{
				SetImage(cell[cellnum!][image]$,cell[cellnum!][x1]!,cell[cellnum!][y1]!,cell[cellnum!][width]!,cell[cellnum!][height]!,canvas!)
			}
		}
	}
}


Method AddButtons()
{
	for(buttoncount! = 0; buttoncount! < buttonnumbo!; buttoncount!++)
	{
		cellnum!=button[buttoncount!]!
		SetButton(cell[cellnum!][image]$,cellnum!,cell[cellnum!][x1]!,cell[cellnum!][y1]!,cell[cellnum!][width]!,cell[cellnum!][height]!)
	}
	kill(buttoncount!)
	kill(cellnum!)
	buttonnumbo!=0
}



Method RenderAllCells()
{
	getres(resx!,resy!)
	drawallcells! = createCanvas(resx!,resy!)
	for(layernum! = 0; layernum! <= max_layer!; layernum!++)
	{
		for(num! = 0; num! < number_of_cells!; num!++)
		{
			If(cell[num!][layer]!==layernum!)
			{
				RenderCell(num!,drawallcells!)
			}
		}
	}
	kill(num!)
	kill(layernum!)
	DrawCanvas(drawallcells!,0,0)
	KillCanvas(drawallcells!)
	AddButtons()
}

Method SetStringType(var1$,var2$)
{
	Switch(var2$)
	{
		case("literal") {
			varf$=var1$+"$"
		}
		case("numeric") {
			varf$=var1$+"!"
		}
	}
	returnmethod(varf$)
}





